# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..56\n"; }
END {print "not ok 1\n" unless $loaded;}
use Lingua::EN::Numbers qw ( to_words );
$loaded = 1;
print "ok 1\n";
$count=2;

######################### End of black magic.

$neg = 0;
while (defined($str = <DATA>))
{
	$fail = 0;
	chomp $str;
	next unless $str =~ /./;
	$val = to_words $str;
	$bad = "$str:\n";
	$res = <DATA>; chomp $res;
	$fail ||= $val ne $res;
	foreach $i (1..3)
	{
		$val = to_words $str, $i;
		$res = <DATA>; chomp $res;
		$fail ||= $val ne $res;
		$bad .= "	-> $res\n" if $val ne $res;
	}

	print "not " if $fail;
	print "ok ", $count++, "\n";
	# print "\n$bad\n" if $fail;
}

__DATA__
0
zero
zero
zero
zero

1
one
one
one
one

2
two
two
two
two

3
three
three
three
three

4
four
four
four
four

5
five
five
five
five

6
six
six
six
six

7
seven
seven
seven
seven

8
eight
eight
eight
eight

9
nine
nine
nine
nine

10
ten
one, zero
ten
ten

11
eleven
one, one
eleven
eleven

12
twelve
one, two
twelve
twelve

13
thirteen
one, three
thirteen
thirteen

14
fourteen
one, four
fourteen
fourteen

15
fifteen
one, five
fifteen
fifteen

16
sixteen
one, six
sixteen
sixteen

17
seventeen
one, seven
seventeen
seventeen

18
eighteen
one, eight
eighteen
eighteen

19
nineteen
one, nine
nineteen
nineteen

20
twenty
two, zero
twenty
twenty

21
twenty-one
two, one
twenty-one
twenty-one

29
twenty-nine
two, nine
twenty-nine
twenty-nine

99
ninety-nine
nine, nine
ninety-nine
ninety-nine

100
one hundred
one, zero, zero
ten, zero
one zero zero

101
one hundred and one
one, zero, one
ten, one
one zero one

110
one hundred and ten
one, one, zero
eleven, zero
one ten

111
one hundred and eleven
one, one, one
eleven, one
one eleven

900
nine hundred
nine, zero, zero
ninety, zero
nine zero zero

999
nine hundred and ninety-nine
nine, nine, nine
ninety-nine, nine
nine ninety-nine

1000
one thousand
one, zero, zero, zero
ten, zero zero
one zero zero, zero

1001
one thousand and one
one, zero, zero, one
ten, zero one
one zero zero, one

1010
one thousand and ten
one, zero, one, zero
ten, ten
one zero one, zero

1100
one thousand, one hundred
one, one, zero, zero
eleven, zero zero
one ten, zero

2000
two thousand
two, zero, zero, zero
twenty, zero zero
two zero zero, zero

10000
ten thousand
one, zero, zero, zero, zero
ten, zero zero, zero
one zero zero, zero zero

100000
one hundred thousand
one, zero, zero, zero, zero, zero
ten, zero zero, zero zero
one zero zero, zero zero zero

100001
one hundred thousand and one
one, zero, zero, zero, zero, one
ten, zero zero, zero one
one zero zero, zero zero one

123456
one hundred and twenty-three thousand, four hundred and fifty-six
one, two, three, four, five, six
twelve, thirty-four, fifty-six
one twenty-three, four fifty-six

0123456
one hundred and twenty-three thousand, four hundred and fifty-six
zero, one, two, three, four, five, six
zero one, twenty-three, forty-five, six
zero twelve, three forty-five, six

1234567
one million, two hundred and thirty-four thousand, five hundred and sixty-seven
one, two, three, four, five, six, seven
twelve, thirty-four, fifty-six, seven
one twenty-three, four fifty-six, seven

12345678
twelve million, three hundred and forty-five thousand, six hundred and seventy-eight
one, two, three, four, five, six, seven, eight
twelve, thirty-four, fifty-six, seventy-eight
one twenty-three, four fifty-six, seventy-eight

12_345_678
twelve million, three hundred and forty-five thousand, six hundred and seventy-eight
one, two, three, four, five, six, seven, eight
twelve, thirty-four, fifty-six, seventy-eight
one twenty-three, four fifty-six, seventy-eight

1234,5678
twelve million, three hundred and forty-five thousand, six hundred and seventy-eight
one, two, three, four, five, six, seven, eight
twelve, thirty-four, fifty-six, seventy-eight
one twenty-three, four fifty-six, seventy-eight

1234567890
one billion, two hundred and thirty-four million, five hundred and sixty-seven thousand, eight hundred and ninety
one, two, three, four, five, six, seven, eight, nine, zero
twelve, thirty-four, fifty-six, seventy-eight, ninety
one twenty-three, four fifty-six, seven eighty-nine, zero

123456789012345
one hundred and twenty-three trillion, four hundred and fifty-six billion, seven hundred and eighty-nine million, twelve thousand, three hundred and forty-five
one, two, three, four, five, six, seven, eight, nine, zero, one, two, three, four, five
twelve, thirty-four, fifty-six, seventy-eight, ninety, twelve, thirty-four, five
one twenty-three, four fifty-six, seven eighty-nine, zero twelve, three forty-five

12345678901234567890
twelve quintillion, three hundred and forty-five quadrillion, six hundred and seventy-eight trillion, nine hundred and one billion, two hundred and thirty-four million, five hundred and sixty-seven thousand, eight hundred and ninety
one, two, three, four, five, six, seven, eight, nine, zero, one, two, three, four, five, six, seven, eight, nine, zero
twelve, thirty-four, fifty-six, seventy-eight, ninety, twelve, thirty-four, fifty-six, seventy-eight, ninety
one twenty-three, four fifty-six, seven eighty-nine, zero twelve, three forty-five, six seventy-eight, ninety

0.987654
zero point nine eight seven six five four
zero, point, nine, eight, seven, six, five, four
zero, point, ninety-eight, seventy-six, fifty-four
zero, point, nine eighty-seven, six fifty-four

.987654
point nine eight seven six five four
point, nine, eight, seven, six, five, four
point, ninety-eight, seventy-six, fifty-four
point, nine eighty-seven, six fifty-four

9.87654
nine point eight seven six five four
nine, point, eight, seven, six, five, four
nine, point, eighty-seven, sixty-five, four
nine, point, eight seventy-six, fifty-four

98.7654
ninety-eight point seven six five four
nine, eight, point, seven, six, five, four
ninety-eight, point, seventy-six, fifty-four
ninety-eight, point, seven sixty-five, four

987.654
nine hundred and eighty-seven point six five four
nine, eight, seven, point, six, five, four
ninety-eight, seven, point, sixty-five, four
nine eighty-seven, point, six fifty-four

9876.54
nine thousand, eight hundred and seventy-six point five four
nine, eight, seven, six, point, five, four
ninety-eight, seventy-six, point, fifty-four
nine eighty-seven, six, point, fifty-four

98765.4
ninety-eight thousand, seven hundred and sixty-five point four
nine, eight, seven, six, five, point, four
ninety-eight, seventy-six, five, point, four
nine eighty-seven, sixty-five, point, four

101.202.303
one hundred and one point two zero two three zero three
one, zero, one, point, two, zero, two, point, three, zero, three
ten, one, point, twenty, two, point, thirty, three
one zero one, point, two zero two, point, three zero three
